#ifndef _CONVERT_H_
#define _CONVERT_H_

#include "nonstd.h"
#include "nonstd_math.h"
#include "nonstd_stl.h"
#include "2d.h"

typedef XY<double> Pt2D;


struct Convert
{
public:
  static int toInt(string s);
  static float toFloat(string s);
  static string toLowerCase(string s);
  static string toUpperCase(string s);
  static char toLowerCase(char c);
  static char toUpperCase(char c);
  template<class T> static string _toString(const T& value);
  static string toString(unsigned int v);
  static string toString(int v);
  static string toString(short v);
  static string toString(float v);
  static string toString(double v);// ze niby w badzie ma nie byc? ale w frams na pewno ma byc bo tu same double
  static string zeroPad(string s,int l) {while((int)s.length()<l) s=string("0")+s; return s;}

  static double toRadians(double kat) {return kat*M_PI/180;}
  static double toDegrees(double kat) {return kat/M_PI*180;}
  static double atan_2(double y,double x) {if (x==0 && y==0) return 0; else return atan2(y,x);}

	static double odleglosc_sq(double x1,double y1,double x2,double y2) //odleglosc do kwadratu, wystarczy do porownywania
	{double dx=x2-x1, dy=y2-y1; return dx*dx+dy*dy;}
	static double odleglosc_sq(const Pt2D& p1,const Pt2D& p2) //odleglosc do kwadratu
	{return odleglosc_sq(p1.x,p1.y,p2.x,p2.y);}

	static double odleglosc(double x1,double y1,double x2,double y2)	{return sqrt(odleglosc_sq(x1,y1,x2,y2));}
	static double odleglosc(const Pt2D& p1,const Pt2D& p2)
	{return sqrt(odleglosc_sq(p1,p2));}
	
  //static float odleglosc(int x1,int y1,int x2,int y2) {float dx=x1-x2; float dy=y1-y2; return sqrt(dx*dx+dy*dy);}
  //static float odleglosc(float x1,float y1,float x2,float y2) {return sqrt(odleglosc_sq(x1,y1,x2,y2));}
  //static float odleglosc_sq(float x1,float y1,float x2,float y2) {float dx=x1-x2; float dy=y1-y2; return dx*dx+dy*dy;}

  static struct tm localtime(const time_t &timep);//jak ::localtime ale zwraca strukture zamiast wskaznika, ref w parametrze dla wygodnego wywolywania
  static string asctime(const struct tm &tm);//jak ::asctime ale thread safe i bez glupiego \n na koncu, ref w parametrze dla wygodnego wywolywania
};



struct Kat //znormalizowany kt w radianach [0,2pi) i stopniach [0,360) z obliczonymi sinus i cosinus oraz intem [0,359]
{
private:
	double kat; //w radianach, read-only
public:
	double kat_stopnie; //read-only
	int kat_stopnie_int; //read-only

	Kat() {set(0);}
	Kat(double k) {set(k);}
	Kat(Kat &kt) {set(kt.get());}
	Kat(double dy,double dx) {set(dy,dx);}
	void set(double k) {k=fmod(k,M_PI*2); if (k<0) k+=M_PI*2; kat=k; sinus=sin(k); cosinus=cos(k); kat_stopnie=Convert::toDegrees(kat); kat_stopnie_int=roundToInt(kat_stopnie); kat_stopnie_int%=360; }
	void set(double dy,double dx) {set(Convert::atan_2(dy,dx));}
	void add(double dk) {set(kat+dk);}
	void add(Kat &kt) {set(kat+kt.get());}
	double get() {return kat;}
	double sinus,cosinus;
};



#endif
